﻿unit Kramer;

function Solve(a: array[,] of real; b: array of real): array of real;
begin
  case b.Length of
    3:
      begin
        var d := a[0, 0] * (a[1, 1] * a[2, 2] - a[2, 1] * a[1, 2]) -
            a[0, 1] * (a[1, 0] * a[2, 2] - a[2, 0] * a[1, 2]) +
            a[0, 2] * (a[1, 0] * a[2, 1] - a[2, 0] * a[1, 1]);
        if d = 0 then
          Result := new real[0]
        else
    begin
          var d1 := b[0] * (a[1, 1] * a[2, 2] - a[2, 1] * a[1, 2]) -
                      a[0, 1] * (b[1] * a[2, 2] - b[2] * a[1, 2]) +
            a[0, 2] * (b[1] * a[2, 1] - b[2] * a[1, 1]);
          var d2 := a[0, 0] * (b[1] * a[2, 2] - b[2] * a[1, 2]) -
                      b[0] * (a[1, 0] * a[2, 2] - a[2, 0] * a[1, 2]) +
            a[0, 2] * (a[1, 0] * b[2] - a[2, 0] * b[1]);
          var d3 := a[0, 0] * (a[1, 1] * b[2] - a[2, 1] * b[1]) -
                      a[0, 1] * (a[1, 0] * b[2] - a[2, 0] * b[1]) +
            b[0] * (a[1, 0] * a[2, 1] - a[2, 0] * a[1, 1]);
          Result := Arr(d1 / d, d2 / d, d3 / d);
        end
      end;
    2:
      begin
        var d := a[0, 0] * a[1, 1] - a[1, 0] * a[0, 1];
        if d = 0 then
          Result := new real[0]
        else
    begin
          var d1 := b[0] * a[1, 1] - b[1] * a[0, 1];
          var d2 := b[1] * a[0, 0] - b[0] * a[1, 0];
          Result := Arr(d1 / d, d2 / d);
        end
      end;
  else
    Result := new real[0];
  end
end;

end.