﻿function NewMatrix(m, n: integer): array[,] of integer;// p08007
begin
  Result := MatrRandom(m, n, -50, 50);
  Result.Println(4);
  Println('-' * 4 * n)
end;

begin
  var a := NewMatrix(3, 5);
  var b := NewMatrix(2, 7);
  Println('Min(A) =', a.ElementsByRow.Min);
  Println('Среднее по B:', b.ElementsByRow.Average);
  Print('Сумма по колонкам в A:');
  a.Cols.Select(t -> t.Sum).Println;
  Print('Сумма кубов модулей элементов полследней строки А:');
  a.RowSeq(a.RowCount - 1).Select(t -> Abs(t ** 3)).Sum.Println;
  Print('Максимальный элемент в B:');
  var max := b.ElementsWithIndices.MaxBy(t -> t[0]);
  $'B[{max[1]+1},{max[2]+1}] = {max[0]}'.Println;
  Writeln('Выборка строк и столбцов матрицы А по индексам');
  a.MatrSlice(Arr(0, 2), ArrGen(2, i -> 2 * i + 1)).Println(4);
  Writeln('Срез матрицы B');
  b.MatrSlice(0, 1, 3, 5).Println(4)
end.