﻿// p10015
type
  MyStr = record
    f1: string; // Фамилия, И.О.
    f2: string; // дата рождения дд.мм.гггг
    f3: integer // оклад
  end;

function MyHash(s: string): integer;
begin
  var (size, mult) := (8, 31);
  var sum: longword := 0;
  foreach var c in s do
    sum := sum * mult + Ord(c);
  Result := sum mod size;
end;

procedure ToHash(fio, dr: string; oklad: integer; t: array of MyStr);
begin
  var h := MyHash(fio);
  t[h].f1 := fio;
  t[h].f2 := dr;
  t[h].f3 := oklad
end;

begin
  var HashTable := new MyStr[8];
  ToHash('Иванов И.И.', '12.07.1970', 62000, HashTable);
  ToHash('Петров П.П.', '03.11.1982', 36000, HashTable);
  ToHash('Сидорова С.С.', '21.04.1974', 57300, HashTable);
  ToHash('Козлов К.К.', '09.03.1985', 28500, HashTable);
  ToHash('Тарасова Т.Т.', '11.11.1992', 24000, HashTable);
  HashTable.PrintLines;
  // пример извлечения данных
  var buf := HashTable[MyHash('Сидорова С.С.')];
  Writeln(buf.f1, ', дата рождения ', buf.f2, ', оклад ', buf.f3)
end.