﻿// p13007
type
  SortByInsert = class
  
  private 
    ma: array of integer;
    procedure Sort;
    begin
      for var i := 1 to ma.High do
        if ma[i - 1] > ma[i] then
        begin
          var (p, j) := (ma[i], i - 1);
          while (j >= 0) and (ma[j] > p) do
            (ma[j + 1], j) := (ma[j], j - 1);
          ma[j + 1] := p
        end;
    end;
  
  public 
    constructor(pa: array of integer);
    begin
      ma := pa;
      Sort
    end;
    
    property ia[i: integer]: integer
    read ma[i]
    write
      begin
        ma[i] := value;
        Sort
      end;
    default;
    property a: array of integer read ma;
  
  end;

begin
  var a := ArrRandom(15, -50, 50); a.Println;
  var oT := new SortByInsert(a);
  oT.a.Println;
  oT[7] := 0;
  oT.a.Println;
end.