﻿// p13013
type
  Родитель = class
  public 
    procedure Вывод; virtual :=
        Println(Self.GetType.Name + ': Родитель');
  end;
  
  Дочка = class(Родитель)
  public 
    procedure Вывод; override :=
        Println(Self.GetType.Name + ': Дочка');
  end;
  
  Внучка = class(Дочка)
  public 
    procedure Вывод; override :=
        Println(Self.GetType.Name + ': Внучка');
  end;
  
  Правнучка = class(Внучка)
  public 
    procedure Вывод; override :=
        Println(Self.GetType.Name + ': Правнучка');
  end;

begin
  Seq&<Родитель>(new Дочка, new Правнучка, new Родитель, new Внучка)
      .Foreach(b -> begin b.Вывод end)
end.