﻿// p13017
type
  Фигура = class
    function Площадь: real; abstract;
    procedure Вывести; abstract;
  end;
  
  Прямоугольник = class(Фигура)
    Длина: real;
    Ширина: real;
    constructor(Длина, Ширина: real);
    begin
      Self.Длина := Длина;
      Self.Ширина := Ширина
    end;
    function Площадь: real; override := Длина * Ширина;
    procedure Вывести; override :=
        $'{Длина} x {Ширина} = {Площадь}'.Println;
  end;
  
  Квадрат = class(Фигура)
    Сторона: real;
    constructor(Сторона: real);
    begin
      Self.Сторона := Сторона;
    end;
    function Площадь: real; override := Sqr(Сторона);
    procedure Вывести; override :=
        $'{Сторона} x {Сторона} = {Площадь}'.Println; 
  end;

begin
  var L := new List<Фигура>;
  L.Add(new Прямоугольник(12, 15.5));
  L.Add(new Прямоугольник(18.2, 9.4));
  L.Add(new Квадрат(15));
  foreach var p in L do
    p.Вывести
end.