﻿// p07009
function Comp<T>(a, b: T): integer;
  where T: IComparable<T>;
begin
  if a = b then Result := 0
  else
  if a.CompareTo(b) > 0 then Result := 1
  else Result := -1
end;

begin
  Comp(3, 5).Println;               // -1
  Comp(4.2, 2.7).Println;           //  1
  Comp&<real>(4, 5.2).Println;      // -1
  Comp('x', 'X').Println;           //  1
  Comp(False, True).Println;        // -1
  Comp('Корова', 'Собака').Println; // -1
  Comp(1.0, 1 + 1e-16).Println      //  0
end.