﻿// p09010
type
  Вершина = record
    x, y: integer
  end;
  
  Треугольник = record
    A, B, C: Вершина
  end;

function Длина(A, B: Вершина) := 
    Sqrt((B.x - A.x) ** 2 + (B.y - A.y) ** 2);

function Периметр(p: Треугольник) :=
    Длина(p.A, p.B) + Длина(p.B, p.C) + Длина(p.C, p.A);

function СоздатьВершину: Вершина;
begin
  (Result.x, Result.y) := Random2(-99, 99);
end;

function СоздатьТреугольник: Треугольник;
begin
  Result.A := СоздатьВершину;
  Result.B := СоздатьВершину;
  Result.C := СоздатьВершину
end;

begin
  var n := ReadInteger('Количество треугольников:');
  var f := CreateFile&<Треугольник>('Test.bin');
  loop n do
    Write(f, СоздатьТреугольник);
  $'Pmax={f.Elements.Select(t->Периметр(t)).Max:f1}'.Println;
  f.Close
end.