﻿// p10020
type
  Товар = class(IComparable<Товар>)
  private 
    Наим: string; // наименование товара
    Цена: real; // цена единицы товара в рублях
    Кол: real// запас товара
  public 
    constructor(Наим: string; Цена: real; Кол: real);
    begin
      (Self.Наим, Self.Цена, Self.Кол) := (Наим, Цена, Кол)
    end;
    
    function CompareTo(МойТовар: Товар): integer;
    begin
      Result := -МойТовар.Наим.CompareTo(Наим);
      if Result = 0 then Result := МойТовар.Цена.CompareTo(Цена)
    end;
  
  end;

begin
  var Товары := new SortedSet<Товар>;
  Товары.Add(new Товар('Шкаф', 9800, 4));
  Товары.Add(new Товар('Стол', 7200, 6));
  Товары.Add(new Товар('Стул', 1930, 12));
  Товары.Add(new Товар('Стул', 2150, 8));
  Товары.Add(new Товар('Стол', 11300, 6));
  Товары.Add(new Товар('Стул', 2099, 12));
  foreach var Товар1 in Товары do
    Println(Товар1.Наим, Товар1.Цена, Товар1.Кол);
end.