﻿procedure TryCast; // p12010
begin
  var i := 123;
  var s := 'Некоторая строка';
  var obj: object := s;
  try
    i := integer(obj);
    Println('Строка в конце блока try');
  finally
    Println($'В блоке finally процедуры TryCast i = {i}');
  end
end;

begin
  try
    TryCast
  except
    on ex: System.Exception do
    begin
      $'Перехват исключения {ex.GetType()} после блока finally'.Println;
      ex.Message.Println;
      ex.StackTrace.Println
    end
  end
end.