﻿// p13023
type
  Люди = auto class
    Имя: string;
  end;
  
  Сотрудники = class(Люди)
    Компания: string;
    constructor(Имя, Компания: string) :=
        (Self.Имя, Self.Компания) := (Имя, Компания);
    procedure Deconstruct(var Имя, Компания: string) :=
        (Имя, Компания) := (Self.Имя, Self.Компания); 
  end;
  
  Клиенты = class(Люди)
    Банк: string;
    constructor(Банк, Имя: string) :=
        (Self.Банк, Self.Имя) := (Банк, Имя);
    procedure Deconstruct(var Имя, Банк: string) :=
        (Банк, Имя) := (Self.Банк, Self.Имя);
  end;
 
begin
  var ВсеВместе := new List<Люди>;
  ВсеВместе.Add(new Сотрудники('Шура', 'Рога и копыта'));
  ВсеВместе.Add(new Клиенты('СкруджБанк', 'МакДак'));
  ВсеВместе.Add(new Клиенты('ЛунтикБанк', 'Лошарик'));
  foreach var Каждый in ВсеВместе do
    match Каждый with
      Сотрудники(Имя, Компания): Println(Имя, Компания);
      Клиенты(Имя, Банк): Println(Имя, Банк);
    end
end.