﻿// p13028
type
  Дробь = class
  public 
    Числитель: integer;
    Знаменатель := 1;

    constructor(Чис, Знам: integer) :=
        (Числитель, Знаменатель) := (Чис, Знам);
  
    constructor(Чис: integer):= Числитель := Чис;
    
    function ToString: string; override :=
        $'{Числитель}/{Знаменатель}';

end;

function operator -(a: Дробь); extensionmethod :=
    new Дробь(-a.Числитель, a.Знаменатель);

function operator +(a, b: Дробь); extensionmethod := 
    new Дробь(a.Числитель * b.Знаменатель +
    b.Числитель * a.Знаменатель,
    a.Знаменатель * b.Знаменатель);
    
function operator *(a, b: Дробь); extensionmethod :=
    new Дробь(a.Числитель * b.Числитель,
    a.Знаменатель * b.Знаменатель);
    
function operator /(a, b: Дробь); extensionmethod :=
    new Дробь(a.Числитель * b.Знаменатель,
    b.Числитель * a.Знаменатель);

begin
  var a := new Дробь(3, 4);
  var b := new Дробь(-2, 5);
  var c := (a + b) / (a + (-b));
  Writeln(c) // 140/460
end.