﻿type
  Tabula = auto class
  public 
    a, b, h: real;
    f: real-> real;
    
    function ToTab: sequence of (real, real);
    begin
      if h <> 0 then
      begin
        if b < a then Swap(a, b);
        var n := Trunc((b - a) / h) + 1;
        for var i := 1 to n do
        begin
          var x := a + h * (i - 1);
          yield (x, f(x))
        end
      end;
    end;
  
  end;

function OutTab(Self: sequence of (real, real); mx, nx, my, ny: integer):
    sequence of(real, real); extensionmethod;
begin
  foreach var s in Self do
    Writeln(s[0]:mx:nx, s[1]:my:ny);
  Result := Self
end;

begin
  var t := new Tabula(-4 * Pi, 5 * Pi, pi / 3,
      x -> 3 * x * Cos(x) ** 2 / (1.1 + Sin(x)));
  t.ToTab.OutTab(13, 9, 20, 9).Select(t -> t[1]).Max.Println;
end.