﻿type
  R = record
  a, b, c: integer;
  end;

function ТреугольникВозможен(p: R): boolean;
begin
  var (a, b, c) := (p.a, p.b, p.c);
  Result := (a + b > c) and (a + c > b) and (b + c > a)
end;

function Площадь(p: R): real;
begin
  var (a, b, c) := (p.a, p.b, p.c);
  var pp := (a + b + c) / 2;
  Result := Sqrt(pp * (pp - a) * (pp - b) * (pp - c))
end;

begin
  var n := 500000;
  var fn := 'MyFile.bin';
  var d: R; // буфер обмена данными
  var f: file of R;
  Assign(f, fn);
  f.Rewrite;
  loop n do
  begin
    (d.a, d.b, d.c) := Random3(1, 99);
    Write(f, d);
  end;
  var ft: file of R;
  Assign(ft, 'Temp.tmp');
  ft.Rewrite;
  f.Seek(0);
  while not Eof(f) do
  begin
    Read(f, d);
    if ТреугольникВозможен(d) then
      Write(ft, d)
  end;
  ft.Close;
  f.Close;
  DeleteFile(fn);
  Rename(ft, fn);
  var s := f.Elements&<R>.Select(t -> Площадь(t)).Average;
  $'Средняя площадь равна {s:f3}'.Println
end.